#
# , CORE SCRIPT. (written by YAMASHINA Hio)
#

package Rishu;

use strict;

sub import
{
  my $pkg = shift;
  my $callpkg = caller(0);
  print "caller [$callpkg]\n";
  {
	no strict qw(refs);
	foreach( qw(exit die eval) )
	{
      *{"$callpkg\::$_"} = \&{"$pkg\::$_"};
	}
  }
}

sub die
{
  shift if( $_[0] && $_[0] eq 'Rishu' );
  print "Rishu::die\n";
  CORE::die Rishu::make_errmsg(@_);
}

sub eval
{
  shift if( $_[0] && $_[0] eq 'Rishu' );
  my $code = shift;
  local($SIG{__DIE__}) = 'DEFAULT';
  if( !defined($code) )
  {
    $@ = Rishu::make_errmsg('Rishu::eval, Param[1] is undefined.');
    return undef;
  }
  if( ref($code) ne 'CODE' && ref($code) )
  {
    $@ = Rishu::make_errmsg('Rishu::eval, Param[1] is not CODE or scalar.');
    return undef;
  }
  if( wantarray )
  {
    my @res = ref($code) ? CORE::eval{ &$code } : CORE::eval($code);
    $@ && $@ =~ /^\0\0Rishu::/ and die $@;
    @res;
  }else
  {
    my $res = ref($code) ? CORE::eval{ &$code } : CORE::eval($code);
    $@ && $@ =~ /^\0\0Rishu::/ and die $@;
    $res;
  }
}

sub exit
{
  print "Rishu::exit\n";
  CORE::die(make_errmsg("\0\0Rishu::exit"));
}

sub make_errmsg
{
  my $msg = join('',@_);
  if( $msg !~ /\n$/ )
  {
    my $i=0;
    for(;;)
    {
      my ($pkg,$file,$line) = caller($i++);
      if( $pkg ne 'Rishu' )
      {
	$msg .= " at $file line $line\n";
	last;
      }
    }
  }
  $msg;
}


1;
